/* $Workfile: OsaLinuxDmp.c $   $Revision: 5 $    $Modtime: 10/23/08 5:48p $  */
/*******************************************************************************

  Odin TeleSystems Inc.

  OTX Telecom Adapter Driver

  @doc internal

  @module

  @normal Copyright (C) Odin TeleSystems Inc., 2007-2008, All Rights Reserved

*******************************************************************************/

/******************************************************************************
  
  Driver exported entry/exit functions.

  Some of the Linux kernel headers don't like to be compiled with g++ (C++)
  so we need a file that is pure C. This file has two purposes: it implements
  the two Linux module specific entry exit routines, init_module and
  cleanup_module, the file operation callbacks, and also some routines that's
  needed for proc operations.

******************************************************************************/
// This is the only place where this file should be included
// It's unlikely it will be needed anywhere else but if so
// __NO_VERSION__ must be defined before inclusion at the
// other places

// Only include in DaVinci
#ifdef DAVINCI


#include <linux/config.h>
#include <linux/kernel.h>
#include <linux/module.h>
#include <linux/init.h>
//#include <linux/proc_fs.h>
#include <linux/ioport.h>
#include <linux/interrupt.h>	// struct tasklet_struct

#include <asm/uaccess.h>



#include "../OsaRtl.h"  // For OSA_DPRINTF
//#include "OsaLinuxRtl.h"  // For OSA_DPRINTF

#include "OsaLinuxDmp.h"


/******************************************************************************
  OsaLinuxDmpReadReg32
    return 0=>OK, -1=>error
******************************************************************************/
int OsaLinuxDmpReadReg32(unsigned long address, unsigned long *value)
{
  int rc = 0;

  *value = *((volatile u32*) io_p2v(address));

  //OSA_DPRINTF(("DmpReadReg32: Addr 0x%X value 0x%X\n", (unsigned int)address, (unsigned int)*value));

  return rc;
}

/******************************************************************************
  OsaLinuxDmpReadReg32
    return 0=>OK, -1=>error
******************************************************************************/
int OsaLinuxDmpWriteReg32(unsigned long address, unsigned long value)
{
  int rc = 0;

  //OSA_DPRINTF(("DmpWriteReg32: Addr 0x%X value 0x%X\n", (unsigned int)address, (unsigned int)value));

  *((volatile u32*) io_p2v(address)) = value;

  return rc;
}

#endif // DAVINCI
